package com.jeequan.jeepay.core.model.oauth2;

import com.alibaba.fastjson.JSON;
import com.jeequan.jeepay.core.utils.StringKit;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;

/***
* 支付宝 oauth2相关参数配置
*
* @author terrfly
*
* @date 2022/11/9 14:27
*/
@Data
public class AlipayOauth2Params extends Oauth2Params{

    /** 是否使用子商户的 小程序账号（ 目前仅小程序使用 ） 1-是 0-否  **/
    private Byte isUseSubmchAccount;

    /** 是否沙箱环境 */
    private Byte sandbox;

    /** pid */
    private String pid;

    /** appId */
    private String appId;

    /** privateKey */
    private String privateKey;

    /** alipayPublicKey */
    private String alipayPublicKey;

    /** 签名方式 **/
    private String signType;

    /** 是否使用证书方式 **/
    private Byte useCert;

    /** app 证书 **/
    private String appPublicCert;

    /** 支付宝公钥证书（.crt格式） **/
    private String alipayPublicCert;

    /** 支付宝根证书 **/
    private String alipayRootCert;

    /** 支付宝 页面路径  **/
    private String pagePath;

    /** 支付宝小程序参数 **/
    private AlipayOauth2Params liteParams;

    @Override
    public String deSenData() {

        AlipayOauth2Params isvParams = this;
        if (StringUtils.isNotBlank(isvParams.privateKey)) {
            isvParams.setPrivateKey(StringKit.str2Star(isvParams.privateKey, 4, 4, 6));
        }
        if (StringUtils.isNotBlank(isvParams.alipayPublicKey)) {
            isvParams.setAlipayPublicKey(StringKit.str2Star(isvParams.alipayPublicKey, 6, 6, 6));
        }

        AlipayOauth2Params liteExtParams = isvParams.liteParams;
        if (liteExtParams != null && StringUtils.isNotBlank(liteExtParams.privateKey)) {
            liteExtParams.setPrivateKey(StringKit.str2Star(liteExtParams.privateKey, 4, 4, 6));
        }
        if (liteExtParams != null && StringUtils.isNotBlank(liteExtParams.alipayPublicKey)) {
            liteExtParams.setAlipayPublicKey(StringKit.str2Star(liteExtParams.alipayPublicKey, 6, 6, 6));
        }

        return JSON.toJSONString(isvParams);
    }

}
